searchData={"items":[{"type":"behaviour","title":"Sqids","doc":"Sqids API\n\n> ℹ️ Check out the [docs entry page](readme.html) for an example on how to `use\n> Sqids` to generate a module that bypasses the need to pass along `sqids` context\n> on every encode or decode call.","ref":"Sqids.html"},{"type":"callback","title":"Sqids.child_spec/0","doc":"Returns Supervisor child spec for callback module.","ref":"Sqids.html#c:child_spec/0"},{"type":"function","title":"Sqids.decode!/2","doc":"Decodes an `id` into zero or more `numbers` according to `sqids`'s alphabet.\n\nLike in the [reference implementation](https://github.com/sqids/sqids-spec),\nthe presence of unknown characters within `id` will result in an empty list\nbeing returned.","ref":"Sqids.html#decode!/2"},{"type":"function","title":"Sqids.encode/2","doc":"Tries to encode zero or more `numbers` into as an `id`, according to\n`sqids`'s alphabet, blocklist, and minimum length. Returns an error\notherwise.","ref":"Sqids.html#encode/2"},{"type":"function","title":"Sqids.encode!/2","doc":"Encodes zero or more `numbers` into an `id`, according to `sqids`'s alphabet,\nblocklist, and minimum length. Raises in case of error.","ref":"Sqids.html#encode!/2"},{"type":"function","title":"Sqids.new/1","doc":"Creates a context used for both encoding and decoding.\n\nCan receive a list of zero or more `t:opts/0`:\n* `alphabet`: a case and order -sensitive string containing the chars of which generated IDs will be made of;\n* `min_length`: the minimum length of your generated IDs (padding added if needed);\n* `blocklist`: an enumerable collection of strings which shouldn't appear in generated IDs.\n\nReturns error if any of the `t:opts/0` is invalid.","ref":"Sqids.html#new/1"},{"type":"type","title":"Sqids.enumerable/1","doc":"Wrapper type for Elixir 1.13 or older","ref":"Sqids.html#t:enumerable/1"},{"type":"type","title":"Sqids.opts/0","doc":"Opts for `new/1`","ref":"Sqids.html#t:opts/0"},{"type":"opaque","title":"Sqids.t/0","doc":"Context for Sqids","ref":"Sqids.html#t:t/0"},{"type":"module","title":"Sqids.Agent","doc":"Storage for `Sqids` shared state.\nLike stdlib's [Agent](https://hexdocs.pm/elixir/1.15/Agent.html) but using\nOTP's [`persistent_term`](https://www.erlang.org/doc/man/persistent_term).","ref":"Sqids.Agent.html"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [0.1.0] - 2023-10-28\n\n#","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- Elixir implementation of [Sqids](https://sqids.org/)","ref":"changelog.html#added"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2023-present Sqids maintainers.\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Sqids Elixir","doc":"# [Sqids Elixir](https://sqids.org/elixir)\n\n[![](https://img.shields.io/hexpm/v/sqids.svg?style=flat)](https://hex.pm/packages/sqids)\n[![](https://github.com/sqids/sqids-elixir/actions/workflows/ci.yml/badge.svg)](https://github.com/sqids/sqids-elixir/actions/workflows/ci.yml)\n[![Elixir Versions](https://img.shields.io/badge/Elixir-1.7%20to%201.15-blue)](https://elixir-lang.org/)\n[![Erlang Versions](https://img.shields.io/badge/Erlang%2FOTP-21.3%20to%2026-blue)](https://www.erlang.org)\n\n\n[Sqids](https://sqids.org/elixir) (*pronounced \"squids\"*) for Elixir is a\nlibrary for generating YouTube-looking IDs from numbers. These IDs are short,\ncan be generated with a custom alphabet and are collision-free. [Read\nmore](https://sqids.org/faq).\n\nThis is what they look like in URLs:\n```\nhttps://example.com/LchsyE\nhttps://example.com/Uxmq8Y\nhttps://example.com/3CwlG7\n```","ref":"readme.html"},{"type":"extras","title":"Why use them? - Sqids Elixir","doc":"The main purpose is visual: you can use `Sqids` if you'd like to expose integer\nidentifiers in your software as alphanumeric strings.\n\n#","ref":"readme.html#why-use-them"},{"type":"extras","title":"✅ Use Cases - Sqids Elixir","doc":"* **Link shortening**: default alphabet is safe to use in URLs, and common profanity is avoided\n* **Event IDs**: collision-free ID generation\n* **Database lookups**: by decoding IDs back into numbers\n\n#","ref":"readme.html#use-cases"},{"type":"extras","title":"❌ Not Good For - Sqids Elixir","doc":"* **Sensitive data**: this it not an encryption library\n* **User IDs** generated in sequence, or equivalents, can be decoded, revealing\n  user count and/or business growth","ref":"readme.html#not-good-for"},{"type":"extras","title":"Features: - Sqids Elixir","doc":"* 🆔 Generate short IDs from non-negative integers\n* 🤬 Avoid common profanity in generated IDs\n* 🎲 IDs appear randomized when encoding incremental numbers\n* 🧰 Decode IDs back into numbers\n* ↔️ Generate IDs with a minimum length, making them more uniform\n* 🔤 Generate IDs with a custom alphabet\n* 👩‍💻 Available in [multiple programming languages](https://sqids.org)\n* 👯‍♀️ Every equally configured implementation produces the same IDs\n* 🍻 Small library with a permissive license","ref":"readme.html#features"},{"type":"extras","title":"🚀 Getting started - Sqids Elixir","doc":"The package can be installed by adding `sqids` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:sqids, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#getting-started"},{"type":"extras","title":"👩‍💻 Examples - Sqids Elixir","doc":"#","ref":"readme.html#examples"},{"type":"extras","title":"Default configuration - Sqids Elixir","doc":"```elixir\niex> {:ok, sqids} = Sqids.new()\niex> numbers = [1, 2, 3]\niex> id = Sqids.encode!(sqids, numbers)\niex> ^id = \"86Rf07\"\niex> ^numbers = Sqids.decode!(sqids, id)\n```\n\n> **Note**\n> 🚧 Because of the algorithm's design, **multiple IDs can decode back into the\n> same sequence of numbers**. If it's important to your design that IDs are\n> canonical, you have to re-encode decoded numbers and check that the\n> generated ID matches.\n\n#","ref":"readme.html#default-configuration"},{"type":"extras","title":"Convenience: placing Sqids under your app's supervision tree - Sqids Elixir","doc":"This allows you to encode and decode IDs without managing context.\n\nA module is generated with the `Sqids` context stored in a uniquely named\n[`persistent_term`](https://www.erlang.org/doc/man/persistent_term), managed by\na uniquely named process. Both names are derived from the module's.\n\n```elixir\niex> defmodule MyApp.Sqids do\niex>   use Sqids\niex>   \niex>   @impl true\niex>   def child_spec() do\niex>       child_spec([\niex>           # alphabet: alphabet,     # Custom alphabet\niex>           # min_length: min_length, # Padding\niex>           # blocklist: blocklist    # Custom blocklist\niex>       ])\niex>   end\niex> end\niex>\niex>\niex> defmodule MyApp.Application do\niex>   # ...\niex>   def start(_type, _args) do\niex>      children = [\niex>        MyApp.Sqids,\niex>        # ...\niex>      ]\niex>\niex>      opts = [strategy: :one_for_one, name: MyApp.Supervisor]\niex>      Supervisor.start_link(children, opts)\niex>   end\niex> end\niex> {:ok, _} = MyApp.Application.start(:normal, [])\niex>\niex>\niex> numbers = [1, 2, 3]\niex> id = MyApp.Sqids.encode!(numbers)\niex> ^id = \"86Rf07\"\niex> ^numbers = MyApp.Sqids.decode!(id)\n```\n\n#","ref":"readme.html#convenience-placing-sqids-under-your-app-s-supervision-tree"},{"type":"extras","title":"Custom configuration - Sqids Elixir","doc":"Examples of custom configuration follow. All options are applicable to the\ngenerated module shown before.\n\nNote that different options can be used together for further customization.\nCheck the [API reference](https://hexdocs.pm/sqids/api-reference.html) for\ndetails.\n\n#","ref":"readme.html#custom-configuration"},{"type":"extras","title":"Padding: generated IDs have a minimum length - Sqids Elixir","doc":"```elixir\niex> {:ok, sqids} = Sqids.new(min_length: 10)\niex> numbers = [1, 2, 3]\niex> id = Sqids.encode!(sqids, numbers)\niex> ^id = \"86Rf07xd4z\" # instead of \"86Rf07\"\niex> ^numbers = Sqids.decode!(sqids, id)\n```\n\n(Older IDs, for ex. generated with a previous configuration in which padding\nwas not yet enforced or a different length was configured, can still be\ndecoded.)\n\n#","ref":"readme.html#padding-generated-ids-have-a-minimum-length"},{"type":"extras","title":"Using a custom alphabet - Sqids Elixir","doc":"Generated IDs will be only contain characters from the chosen alphabet, which\nis sensitive to both case and order.\n\n```elixir\niex> {:ok, sqids} = Sqids.new(alphabet: \"cdefhjkmnprtvwxy2345689\")\niex> numbers = [1, 2, 3]\niex> id = Sqids.encode!(sqids, numbers)\niex> ^id = \"wc9xdr\"\niex> ^numbers = Sqids.decode!(sqids, id)\n```\n\nIn order to decode IDs back, they need to be in the same alphabet.\n\nFor practical reasons, the standard limits alphabets to ASCII characters.\n\n(Thanks to Ben Wheeler for his\nsuggestion for [a set of unambiguous-looking characters](https://stackoverflow.com/questions/11919708/set-of-unambiguous-looking-letters-numbers-for-user-input/58098360#58098360)\non Stack Overflow.)\n\n#","ref":"readme.html#using-a-custom-alphabet"},{"type":"extras","title":"Profanity: preventing specific words within the generated IDs - Sqids Elixir","doc":"Place [the ID generated with defaults](#default-configuration) in the\nblocklist, replacing [the latter](https://github.com/sqids/sqids-blocklist/) in\nthe process.\n\n```elixir\niex> {:ok, sqids} = Sqids.new(blocklist: [\"86Rf07\"])\niex> numbers = [1, 2, 3]\niex> id = Sqids.encode!(sqids, numbers)\niex> ^id = \"se8ojk\" # see how \"86Rf07\" was censored\niex> ^numbers = Sqids.decode!(sqids, id)\n```","ref":"readme.html#profanity-preventing-specific-words-within-the-generated-ids"},{"type":"extras","title":"📝 License - Sqids Elixir","doc":"[MIT](LICENSE)","ref":"readme.html#license"}],"content_type":"text/markdown"}